/* gpiox1.c - Source Code for Spansion's Evaluation Board Support Package */
/**************************************************************************
* Copyright (C)2011 Spansion LLC. All Rights Reserved . 
*
* This software is owned and published by: 
* Spansion LLC, 915 DeGuigne Dr. Sunnyvale, CA  94088-3453 ("Spansion").
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND 
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software constitutes driver source code for use in programming Spansion's 
* Flash memory components. This software is licensed by Spansion to be adapted only 
* for use in systems utilizing Spansion's Flash memories. Spansion is not be 
* responsible for misuse or illegal use of this software for devices not 
* supported herein.  Spansion is providing this source code "AS IS" and will 
* not be responsible for issues arising from incorrect user implementation 
* of the source code herein.  
*
* SPANSION MAKES NO WARRANTY, EXPRESS OR IMPLIED, ARISING BY LAW OR OTHERWISE, 
* REGARDING THE SOFTWARE, ITS PERFORMANCE OR SUITABILITY FOR YOUR INTENDED 
* USE, INCLUDING, WITHOUT LIMITATION, NO IMPLIED WARRANTY OF MERCHANTABILITY, 
* FITNESS FOR A  PARTICULAR PURPOSE OR USE, OR NONINFRINGEMENT.  SPANSION WILL 
* HAVE NO LIABILITY (WHETHER IN CONTRACT, WARRANTY, TORT, NEGLIGENCE OR 
* OTHERWISE) FOR ANY DAMAGES ARISING FROM USE OR INABILITY TO USE THE SOFTWARE, 
* INCLUDING, WITHOUT LIMITATION, ANY DIRECT, INDIRECT, INCIDENTAL, 
* SPECIAL, OR CONSEQUENTIAL DAMAGES OR LOSS OF DATA, SAVINGS OR PROFITS, 
* EVEN IF SPANSION HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.  
*
* This software may be replicated in part or whole for the licensed use, 
* with the restriction that this Copyright notice must be included with 
* this software, whether used in part or whole, at all times.  
******************************************************************************/
/** \file boardgpio.c
 **
 ** for BULB-BOARD-MINI
 **
 ** History:
 **   - 2014-06-12  1.0  MSc  First Version
 *****************************************************************************/
#include "board.h"
#include "boardgpio.h"
#if BOARD_GPIO == ON

void BoardGpio_AllOutput(void)
{
    BOARD_GPIO_SETDDR(0x003FFFFF);
    BOARD_GPIO_SETPFR(0x00000000);
}

void BoardGpio_AllInput(void)
{
    BOARD_GPIO_SETDDR(0x00000000);
    BOARD_GPIO_SETPFR(0x00000000);
}

void BoardGpio_Set(uint32_t u32Value)
{
    BOARD_GPIO_SET(u32Value);
}

uint32_t BoardGpio_Get(void)
{
    uint32_t u32Temp;
    u32Temp = 0;
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN1) << 0));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN2) << 1));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN3) << 2));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN4) << 3));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN5) << 4));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN6) << 5));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN7) << 6));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN8) << 7));
    u32Temp |= ((uint32_t)((0) << 8));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN10) << 9));
    u32Temp |= ((uint32_t)((0) << 10));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN12) << 11));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN13) << 12));
    u32Temp |= ((uint32_t)((1) << 13));
    u32Temp |= ((uint32_t)((0) << 14));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN16) << 15));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN17) << 16));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN18) << 17));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN19) << 18));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN20) << 19));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN21) << 20));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN22) << 21));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN23) << 22));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN24) << 23));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN25) << 24));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN26) << 25));
    u32Temp |= ((uint32_t)((bBOARD_GPIO_PDIR_PIN27) << 26));
    u32Temp |= ((uint32_t)((1) << 27));
    return (uint32_t)u32Temp;
}

#endif /* BOARD_GPIO == ON */
