/* gpiox1.h - Source Code for Spansion's Evaluation Board Support Package */
/**************************************************************************
* Copyright (C)2011 Spansion LLC. All Rights Reserved . 
*
* This software is owned and published by: 
* Spansion LLC, 915 DeGuigne Dr. Sunnyvale, CA  94088-3453 ("Spansion").
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND 
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software constitutes driver source code for use in programming Spansion's 
* Flash memory components. This software is licensed by Spansion to be adapted only 
* for use in systems utilizing Spansion's Flash memories. Spansion is not be 
* responsible for misuse or illegal use of this software for devices not 
* supported herein.  Spansion is providing this source code "AS IS" and will 
* not be responsible for issues arising from incorrect user implementation 
* of the source code herein.  
*
* SPANSION MAKES NO WARRANTY, EXPRESS OR IMPLIED, ARISING BY LAW OR OTHERWISE, 
* REGARDING THE SOFTWARE, ITS PERFORMANCE OR SUITABILITY FOR YOUR INTENDED 
* USE, INCLUDING, WITHOUT LIMITATION, NO IMPLIED WARRANTY OF MERCHANTABILITY, 
* FITNESS FOR A  PARTICULAR PURPOSE OR USE, OR NONINFRINGEMENT.  SPANSION WILL 
* HAVE NO LIABILITY (WHETHER IN CONTRACT, WARRANTY, TORT, NEGLIGENCE OR 
* OTHERWISE) FOR ANY DAMAGES ARISING FROM USE OR INABILITY TO USE THE SOFTWARE, 
* INCLUDING, WITHOUT LIMITATION, ANY DIRECT, INDIRECT, INCIDENTAL, 
* SPECIAL, OR CONSEQUENTIAL DAMAGES OR LOSS OF DATA, SAVINGS OR PROFITS, 
* EVEN IF SPANSION HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.  
*
* This software may be replicated in part or whole for the licensed use, 
* with the restriction that this Copyright notice must be included with 
* this software, whether used in part or whole, at all times.  
******************************************************************************/
/** \file boardgpio.c
 **
 ** for BULB-BOARD-MINI
 **
 ** History:
 **   - 2014-06-12  1.0  MSc  First Version
 *****************************************************************************/
#ifndef __BOARDGPIO_H__
#define __BOARDGPIO_H__

#include "board.h"
#if BOARD_GPIO == ON
#include "mcu.h"

/*
1    P3A/RTO00_0/TIOA0_1/AIN0_3/SUBOUT_2/RTCCO_2/INT03_0/SCK0_2
2    P3B/RTO01_0/TIOA1_1/BIN0_3/SOT0_2/INT04_0/SCS31_2
3    P3C/RTO02_0/TIOA2_1/ZIN0_3/SIN0_2/INT05_0/SCS30_2
4    P3D/RTO03_0/TIOA3_1/INT06_0/AIN0_0/SCK3_2
5    P3E/RTO04_0/TIOA0_0/BIN0_0/SOT3_2/INT15_0
6    P3F/RTO05_0/TIOA1_0/ZIN0_0/SIN3_2
7    P46/X0A
8    P47/X1A
9    INITX
10   PE0/ADTG_1/DTTI0X_1/INT02_2
11   MD0
12   PE2/X0
13   PE3/X1 
14   5V
15   GND
16   P11/AN01/SIN1_1/INT02_1/FRCK0_2/IC02_0 
17   P12/AN02/SOT1_1/IC00_2/INT01_1 
18   P13/AN03/SCK1_1/SUBOUT_1/IC01_2/RTCCO_1/INT00_1 
19   P23/AN06/SCK0_0/TIOA2_0/IC02_1/AIN0_1/INT04_1
20   P22/AN07/SOT0_0/TIOB2_0/IC03_1/ZIN0_1/INT05_1 
21   P21/SIN0_0/INT06_1/TIOB1_1/IC01_1/BIN0_1/FRCK0_0 
22   P01/SWCLK 
23   P03/SWDIO 
24   P04/SCK3_0/INT03_2/TIOB0_1/IGTRG0_1 
25   P0F/NMIX/SUBOUT_0/CROUT_1/RTCCO_0 
26   P61/SOT3_0/TIOB2_2/DTTI0X_2/SCS11_2
27   P60/SIN3_0/TIOA2_2/INT15_1/IC00_0/IGTRG0_0/SCS10_2
28   VCC
*/


/* Pin1    P3A/RTO00_0/TIOA0_1/AIN0_3/SUBOUT_2/RTCCO_2/INT03_0/SCK0_2 */
#define bBOARD_GPIO_PDOR_PIN1 bFM0P_GPIO_PDOR3_P3A
#define bBOARD_GPIO_PDIR_PIN1 bFM0P_GPIO_PDIR3_P3A
#define bBOARD_GPIO_DDR_PIN1  bFM0P_GPIO_DDR3_P3A
#define bBOARD_GPIO_PFR_PIN1  bFM0P_GPIO_PFR3_P3A
#define bBOARD_GPIO_PCR_PIN1  bFM0P_GPIO_PCR3_P3A

/* Pin2    P3B/RTO01_0/TIOA1_1/BIN0_3/SOT0_2/INT04_0/SCS31_2         */
#define bBOARD_GPIO_PDOR_PIN2 bFM0P_GPIO_PDOR3_P3B
#define bBOARD_GPIO_PDIR_PIN2 bFM0P_GPIO_PDIR3_P3B
#define bBOARD_GPIO_DDR_PIN2  bFM0P_GPIO_DDR3_P3B
#define bBOARD_GPIO_PFR_PIN2  bFM0P_GPIO_PFR3_P3B
#define bBOARD_GPIO_PCR_PIN2  bFM0P_GPIO_PCR3_P3B

/* Pin3    P3C/RTO02_0/TIOA2_1/ZIN0_3/SIN0_2/INT05_0/SCS30_2         */
#define bBOARD_GPIO_PDOR_PIN3 bFM0P_GPIO_PDOR3_P3C
#define bBOARD_GPIO_PDIR_PIN3 bFM0P_GPIO_PDIR3_P3C
#define bBOARD_GPIO_DDR_PIN3  bFM0P_GPIO_DDR3_P3C
#define bBOARD_GPIO_PFR_PIN3  bFM0P_GPIO_PFR3_P3C
#define bBOARD_GPIO_PCR_PIN3  bFM0P_GPIO_PCR3_P3C

/* Pin4    P3D/RTO03_0/TIOA3_1/INT06_0/AIN0_0/SCK3_2                 */
#define bBOARD_GPIO_PDOR_PIN4 bFM0P_GPIO_PDOR3_P3D
#define bBOARD_GPIO_PDIR_PIN4 bFM0P_GPIO_PDIR3_P3D
#define bBOARD_GPIO_DDR_PIN4  bFM0P_GPIO_DDR3_P3D
#define bBOARD_GPIO_PFR_PIN4  bFM0P_GPIO_PFR3_P3D
#define bBOARD_GPIO_PCR_PIN4  bFM0P_GPIO_PCR3_P3D

/* Pin5    P3E/RTO04_0/TIOA0_0/BIN0_0/SOT3_2/INT15_0                 */
#define bBOARD_GPIO_PDOR_PIN5 bFM0P_GPIO_PDOR3_P3E
#define bBOARD_GPIO_PDIR_PIN5 bFM0P_GPIO_PDIR3_P3E
#define bBOARD_GPIO_DDR_PIN5  bFM0P_GPIO_DDR3_P3E
#define bBOARD_GPIO_PFR_PIN5  bFM0P_GPIO_PFR3_P3E
#define bBOARD_GPIO_PCR_PIN5  bFM0P_GPIO_PCR3_P3E

/* Pin6    P3F/RTO05_0/TIOA1_0/ZIN0_0/SIN3_2                         */
#define bBOARD_GPIO_PDOR_PIN6 bFM0P_GPIO_PDOR3_P3F
#define bBOARD_GPIO_PDIR_PIN6 bFM0P_GPIO_PDIR3_P3F
#define bBOARD_GPIO_DDR_PIN6  bFM0P_GPIO_DDR3_P3F
#define bBOARD_GPIO_PFR_PIN6  bFM0P_GPIO_PFR3_P3F
#define bBOARD_GPIO_PCR_PIN6  bFM0P_GPIO_PCR3_P3F

/* Pin7    P46/X0A                                                   */
#define bBOARD_GPIO_PDOR_PIN7 bFM0P_GPIO_PDOR4_P46
#define bBOARD_GPIO_PDIR_PIN7 bFM0P_GPIO_PDIR4_P46
#define bBOARD_GPIO_DDR_PIN7  bFM0P_GPIO_DDR4_P46
#define bBOARD_GPIO_PFR_PIN7  bFM0P_GPIO_PFR4_P46
#define bBOARD_GPIO_PCR_PIN7  bFM0P_GPIO_PCR4_P46

/* Pin8    P47/X1A                                                   */
#define bBOARD_GPIO_PDOR_PIN8 bFM0P_GPIO_PDOR4_P47
#define bBOARD_GPIO_PDIR_PIN8 bFM0P_GPIO_PDIR4_P47
#define bBOARD_GPIO_DDR_PIN8  bFM0P_GPIO_DDR4_P47
#define bBOARD_GPIO_PFR_PIN8  bFM0P_GPIO_PFR4_P47
#define bBOARD_GPIO_PCR_PIN8  bFM0P_GPIO_PCR4_P47

/* Pin9     INITX                                                    */
// can't be used in software

/* Pin10   PE0/ADTG_1/DTTI0X_1/INT02_2                               */
#define bBOARD_GPIO_PDOR_PIN10 bFM0P_GPIO_PDORE_PE0
#define bBOARD_GPIO_PDIR_PIN10 bFM0P_GPIO_PDIRE_PE0
#define bBOARD_GPIO_DDR_PIN10  bFM0P_GPIO_DDRE_PE0
#define bBOARD_GPIO_PFR_PIN10  bFM0P_GPIO_PFRE_PE0
#define bBOARD_GPIO_PCR_PIN10  bFM0P_GPIO_PCRE_PE0

/* Pin11   MD0                                                       */
// can't be used in software

/* Pin12   PE2/X0                                                    */
#define bBOARD_GPIO_PDOR_PIN12 bFM0P_GPIO_PDORE_PE2
#define bBOARD_GPIO_PDIR_PIN12 bFM0P_GPIO_PDIRE_PE2
#define bBOARD_GPIO_DDR_PIN12  bFM0P_GPIO_DDRE_PE2
#define bBOARD_GPIO_PFR_PIN12  bFM0P_GPIO_PFRE_PE2
#define bBOARD_GPIO_PCR_PIN12  bFM0P_GPIO_PCRE_PE2

/* Pin13   PE3/X1                                                    */
#define bBOARD_GPIO_PDOR_PIN13 bFM0P_GPIO_PDORE_PE3
#define bBOARD_GPIO_PDIR_PIN13 bFM0P_GPIO_PDIRE_PE3
#define bBOARD_GPIO_DDR_PIN13  bFM0P_GPIO_DDRE_PE3
#define bBOARD_GPIO_PFR_PIN13  bFM0P_GPIO_PFRE_PE3
#define bBOARD_GPIO_PCR_PIN13  bFM0P_GPIO_PCRE_PE3

/* Pin14   5V                                                        */
// can't be used in software

/* Pin15   GND                                                       */
// can't be used in software

/* Pin16   P11/AN01/SIN1_1/INT02_1/FRCK0_2/IC02_0                    */
#define bBOARD_GPIO_PDOR_PIN16 bFM0P_GPIO_PDOR1_P11
#define bBOARD_GPIO_PDIR_PIN16 bFM0P_GPIO_PDIR1_P11
#define bBOARD_GPIO_DDR_PIN16  bFM0P_GPIO_DDR1_P11
#define bBOARD_GPIO_PFR_PIN16  bFM0P_GPIO_PFR1_P11
#define bBOARD_GPIO_PCR_PIN16  bFM0P_GPIO_PCR1_P11

/* Pin17   P12/AN02/SOT1_1/IC00_2/INT01_1                            */
#define bBOARD_GPIO_PDOR_PIN17 bFM0P_GPIO_PDOR1_P12
#define bBOARD_GPIO_PDIR_PIN17 bFM0P_GPIO_PDIR1_P12
#define bBOARD_GPIO_DDR_PIN17  bFM0P_GPIO_DDR1_P12
#define bBOARD_GPIO_PFR_PIN17  bFM0P_GPIO_PFR1_P12
#define bBOARD_GPIO_PCR_PIN17  bFM0P_GPIO_PCR1_P12

/* Pin18   P13/AN03/SCK1_1/SUBOUT_1/IC01_2/RTCCO_1/INT00_1           */
#define bBOARD_GPIO_PDOR_PIN18 bFM0P_GPIO_PDOR1_P13
#define bBOARD_GPIO_PDIR_PIN18 bFM0P_GPIO_PDIR1_P13
#define bBOARD_GPIO_DDR_PIN18  bFM0P_GPIO_DDR1_P13
#define bBOARD_GPIO_PFR_PIN18  bFM0P_GPIO_PFR1_P13
#define bBOARD_GPIO_PCR_PIN18  bFM0P_GPIO_PCR1_P13

/* Pin19   P23/AN06/SCK0_0/TIOA2_0/IC02_1/AIN0_1/INT04_1             */
#define bBOARD_GPIO_PDOR_PIN19 bFM0P_GPIO_PDOR2_P23
#define bBOARD_GPIO_PDIR_PIN19 bFM0P_GPIO_PDIR2_P23
#define bBOARD_GPIO_DDR_PIN19  bFM0P_GPIO_DDR2_P23
#define bBOARD_GPIO_PFR_PIN19  bFM0P_GPIO_PFR2_P23
#define bBOARD_GPIO_PCR_PIN19  bFM0P_GPIO_PCR2_P23

/* Pin20   P22/AN07/SOT0_0/TIOB2_0/IC03_1/ZIN0_1/INT05_1             */
#define bBOARD_GPIO_PDOR_PIN20 bFM0P_GPIO_PDOR2_P22
#define bBOARD_GPIO_PDIR_PIN20 bFM0P_GPIO_PDIR2_P22
#define bBOARD_GPIO_DDR_PIN20  bFM0P_GPIO_DDR2_P22
#define bBOARD_GPIO_PFR_PIN20  bFM0P_GPIO_PFR2_P22
#define bBOARD_GPIO_PCR_PIN20  bFM0P_GPIO_PCR2_P22

/* Pin21   P21/SIN0_0/INT06_1/TIOB1_1/IC01_1/BIN0_1/FRCK0_0          */
#define bBOARD_GPIO_PDOR_PIN21 bFM0P_GPIO_PDOR2_P21
#define bBOARD_GPIO_PDIR_PIN21 bFM0P_GPIO_PDIR2_P21
#define bBOARD_GPIO_DDR_PIN21  bFM0P_GPIO_DDR2_P21
#define bBOARD_GPIO_PFR_PIN21  bFM0P_GPIO_PFR2_P21
#define bBOARD_GPIO_PCR_PIN21  bFM0P_GPIO_PCR2_P21

/* Pin22   P01/SWCLK                                                 */
#define bBOARD_GPIO_PDOR_PIN22 bFM0P_GPIO_PDOR0_P01
#define bBOARD_GPIO_PDIR_PIN22 bFM0P_GPIO_PDIR0_P01
#define bBOARD_GPIO_DDR_PIN22  bFM0P_GPIO_DDR0_P01
#define bBOARD_GPIO_PFR_PIN22  bFM0P_GPIO_PFR0_P01
#define bBOARD_GPIO_PCR_PIN22  bFM0P_GPIO_PCR0_P01

/* Pin23   P03/SWDIO                                                 */
#define bBOARD_GPIO_PDOR_PIN23 bFM0P_GPIO_PDOR0_P03
#define bBOARD_GPIO_PDIR_PIN23 bFM0P_GPIO_PDIR0_P03
#define bBOARD_GPIO_DDR_PIN23  bFM0P_GPIO_DDR0_P03
#define bBOARD_GPIO_PFR_PIN23  bFM0P_GPIO_PFR0_P03
#define bBOARD_GPIO_PCR_PIN23  bFM0P_GPIO_PCR0_P03

/* Pin24   P04/SCK3_0/INT03_2/TIOB0_1/IGTRG0_1                       */
#define bBOARD_GPIO_PDOR_PIN24 bFM0P_GPIO_PDOR0_P04
#define bBOARD_GPIO_PDIR_PIN24 bFM0P_GPIO_PDIR0_P04
#define bBOARD_GPIO_DDR_PIN24  bFM0P_GPIO_DDR0_P04
#define bBOARD_GPIO_PFR_PIN24  bFM0P_GPIO_PFR0_P04
#define bBOARD_GPIO_PCR_PIN24  bFM0P_GPIO_PCR0_P04

/* Pin25   P0F/NMIX/SUBOUT_0/CROUT_1/RTCCO_0                         */
#define bBOARD_GPIO_PDOR_PIN25 bFM0P_GPIO_PDOR0_P0F
#define bBOARD_GPIO_PDIR_PIN25 bFM0P_GPIO_PDIR0_P0F
#define bBOARD_GPIO_DDR_PIN25  bFM0P_GPIO_DDR0_P0F
#define bBOARD_GPIO_PFR_PIN25  bFM0P_GPIO_PFR0_P0F
#define bBOARD_GPIO_PCR_PIN25  bFM0P_GPIO_PCR0_P0F

/* Pin26   P61/SOT3_0/TIOB2_2/DTTI0X_2/SCS11_2                       */
#define bBOARD_GPIO_PDOR_PIN26 bFM0P_GPIO_PDOR6_P61
#define bBOARD_GPIO_PDIR_PIN26 bFM0P_GPIO_PDIR6_P61
#define bBOARD_GPIO_DDR_PIN26  bFM0P_GPIO_DDR6_P61
#define bBOARD_GPIO_PFR_PIN26  bFM0P_GPIO_PFR6_P61
#define bBOARD_GPIO_PCR_PIN26  bFM0P_GPIO_PCR6_P61

/* Pin27   P60/SIN3_0/TIOA2_2/INT15_1/IC00_0/IGTRG0_0/SCS10_2        */
#define bBOARD_GPIO_PDOR_PIN27 bFM0P_GPIO_PDOR6_P60
#define bBOARD_GPIO_PDIR_PIN27 bFM0P_GPIO_PDIR6_P60
#define bBOARD_GPIO_DDR_PIN27  bFM0P_GPIO_DDR6_P60
#define bBOARD_GPIO_PFR_PIN27  bFM0P_GPIO_PFR6_P60
#define bBOARD_GPIO_PCR_PIN27  bFM0P_GPIO_PCR6_P60

/* Pin28   VCC                                                       */
// can't be used in software

#define BOARD_GPIO_GET()  ((uint32_t)(\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN1) << 0)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN2) << 1)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN3) << 2)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN4) << 3)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN5) << 4)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN6) << 5)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN7) << 6)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN8) << 7)) |\
                          ((uint32_t)((0) << 8)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN10) << 9)) |\
                          ((uint32_t)((0) << 10)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN12) << 11)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN13) << 12)) |\
                          ((uint32_t)((1) << 13)) |\
                          ((uint32_t)((0) << 14)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN16) << 15)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN17) << 16)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN18) << 17)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN19) << 18)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN20) << 19)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN21) << 20)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN22) << 21)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN23) << 22)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN24) << 23)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN25) << 24)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN26) << 25)) |\
                          ((uint32_t)((bBOARD_GPIO_PDIR_PIN27) << 26)) |\
                          ((uint32_t)((1) << 27))))

#define BOARD_GPIO_SET(x) bBOARD_GPIO_PDOR_PIN1 = ((x & (1 << 0)) >> 0);\
                          bBOARD_GPIO_PDOR_PIN2 = ((x & (1 << 1)) >> 1);\
                          bBOARD_GPIO_PDOR_PIN3 = ((x & (1 << 2)) >> 2);\
                          bBOARD_GPIO_PDOR_PIN4 = ((x & (1 << 3)) >> 3);\
                          bBOARD_GPIO_PDOR_PIN5 = ((x & (1 << 4)) >> 4);\
                          bBOARD_GPIO_PDOR_PIN6 = ((x & (1 << 5)) >> 5);\
                          bBOARD_GPIO_PDOR_PIN7 = ((x & (1 << 6)) >> 6);\
                          bBOARD_GPIO_PDOR_PIN8 = ((x & (1 << 7)) >> 7);\
                          bBOARD_GPIO_PDOR_PIN10 = ((x & (1 << 9)) >> 9);\
                          bBOARD_GPIO_PDOR_PIN12 = ((x & (1 << 11)) >> 11);\
                          bBOARD_GPIO_PDOR_PIN13 = ((x & (1 << 12)) >> 12);\
                          bBOARD_GPIO_PDOR_PIN16 = ((x & (1 << 15)) >> 15);\
                          bBOARD_GPIO_PDOR_PIN17 = ((x & (1 << 16)) >> 16);\
                          bBOARD_GPIO_PDOR_PIN18 = ((x & (1 << 17)) >> 17);\
                          bBOARD_GPIO_PDOR_PIN19 = ((x & (1 << 18)) >> 18);\
                          bBOARD_GPIO_PDOR_PIN20 = ((x & (1 << 19)) >> 19);\
                          bBOARD_GPIO_PDOR_PIN21 = ((x & (1 << 20)) >> 20);\
                          bBOARD_GPIO_PDOR_PIN22 = ((x & (1 << 21)) >> 21);\
                          bBOARD_GPIO_PDOR_PIN23 = ((x & (1 << 22)) >> 22);\
                          bBOARD_GPIO_PDOR_PIN24 = ((x & (1 << 23)) >> 23);\
                          bBOARD_GPIO_PDOR_PIN25 = ((x & (1 << 24)) >> 24);\
                          bBOARD_GPIO_PDOR_PIN26 = ((x & (1 << 25)) >> 25)

#define BOARD_GPIO_SETDDR(x) bBOARD_GPIO_DDR_PIN1 = ((x & (1 << 0)) >> 0);\
                          bBOARD_GPIO_DDR_PIN2 = ((x & (1 << 1)) >> 1);\
                          bBOARD_GPIO_DDR_PIN3 = ((x & (1 << 2)) >> 2);\
                          bBOARD_GPIO_DDR_PIN4 = ((x & (1 << 3)) >> 3);\
                          bBOARD_GPIO_DDR_PIN5 = ((x & (1 << 4)) >> 4);\
                          bBOARD_GPIO_DDR_PIN6 = ((x & (1 << 5)) >> 5);\
                          bBOARD_GPIO_DDR_PIN7 = ((x & (1 << 6)) >> 6);\
                          bBOARD_GPIO_DDR_PIN8 = ((x & (1 << 7)) >> 7);\
                          bBOARD_GPIO_DDR_PIN10 = ((x & (1 << 9)) >> 9);\
                          bBOARD_GPIO_DDR_PIN12 = ((x & (1 << 11)) >> 11);\
                          bBOARD_GPIO_DDR_PIN13 = ((x & (1 << 12)) >> 12);\
                          bBOARD_GPIO_DDR_PIN16 = ((x & (1 << 15)) >> 15);\
                          bBOARD_GPIO_DDR_PIN17 = ((x & (1 << 16)) >> 16);\
                          bBOARD_GPIO_DDR_PIN18 = ((x & (1 << 17)) >> 17);\
                          bBOARD_GPIO_DDR_PIN19 = ((x & (1 << 18)) >> 18);\
                          bBOARD_GPIO_DDR_PIN20 = ((x & (1 << 19)) >> 19);\
                          bBOARD_GPIO_DDR_PIN21 = ((x & (1 << 20)) >> 20);\
                          bBOARD_GPIO_DDR_PIN22 = ((x & (1 << 21)) >> 21);\
                          bBOARD_GPIO_DDR_PIN23 = ((x & (1 << 22)) >> 22);\
                          bBOARD_GPIO_DDR_PIN24 = ((x & (1 << 23)) >> 23);\
                          bBOARD_GPIO_DDR_PIN25 = ((x & (1 << 24)) >> 24);\
                          bBOARD_GPIO_DDR_PIN26 = ((x & (1 << 25)) >> 25)  

#define BOARD_GPIO_SETPFR(x) bBOARD_GPIO_PFR_PIN1 = ((x & (1 << 0)) >> 0);\
                          bBOARD_GPIO_PFR_PIN2 = ((x & (1 << 1)) >> 1);\
                          bBOARD_GPIO_PFR_PIN3 = ((x & (1 << 2)) >> 2);\
                          bBOARD_GPIO_PFR_PIN4 = ((x & (1 << 3)) >> 3);\
                          bBOARD_GPIO_PFR_PIN5 = ((x & (1 << 4)) >> 4);\
                          bBOARD_GPIO_PFR_PIN6 = ((x & (1 << 5)) >> 5);\
                          bBOARD_GPIO_PFR_PIN7 = ((x & (1 << 6)) >> 6);\
                          bBOARD_GPIO_PFR_PIN8 = ((x & (1 << 7)) >> 7);\
                          bBOARD_GPIO_PFR_PIN10 = ((x & (1 << 9)) >> 9);\
                          bBOARD_GPIO_PFR_PIN12 = ((x & (1 << 11)) >> 11);\
                          bBOARD_GPIO_PFR_PIN13 = ((x & (1 << 12)) >> 12);\
                          bBOARD_GPIO_PFR_PIN16 = ((x & (1 << 15)) >> 15);\
                          bBOARD_GPIO_PFR_PIN17 = ((x & (1 << 16)) >> 16);\
                          bBOARD_GPIO_PFR_PIN18 = ((x & (1 << 17)) >> 17);\
                          bBOARD_GPIO_PFR_PIN19 = ((x & (1 << 18)) >> 18);\
                          bBOARD_GPIO_PFR_PIN20 = ((x & (1 << 19)) >> 19);\
                          bBOARD_GPIO_PFR_PIN21 = ((x & (1 << 20)) >> 20);\
                          bBOARD_GPIO_PFR_PIN22 = ((x & (1 << 21)) >> 21);\
                          bBOARD_GPIO_PFR_PIN23 = ((x & (1 << 22)) >> 22);\
                          bBOARD_GPIO_PFR_PIN24 = ((x & (1 << 23)) >> 23);\
                          bBOARD_GPIO_PFR_PIN25 = ((x & (1 << 24)) >> 24);\
                          bBOARD_GPIO_PFR_PIN26 = ((x & (1 << 25)) >> 25)                             

#define BOARD_GPIO_SETPCR(x) bBOARD_GPIO_PCR_PIN1 = ((x & (1 << 0)) >> 0);\
                          bBOARD_GPIO_PCR_PIN2 = ((x & (1 << 1)) >> 1);\
                          bBOARD_GPIO_PCR_PIN3 = ((x & (1 << 2)) >> 2);\
                          bBOARD_GPIO_PCR_PIN4 = ((x & (1 << 3)) >> 3);\
                          bBOARD_GPIO_PCR_PIN5 = ((x & (1 << 4)) >> 4);\
                          bBOARD_GPIO_PCR_PIN6 = ((x & (1 << 5)) >> 5);\
                          bBOARD_GPIO_PCR_PIN7 = ((x & (1 << 6)) >> 6);\
                          bBOARD_GPIO_PCR_PIN8 = ((x & (1 << 7)) >> 7);\
                          bBOARD_GPIO_PCR_PIN10 = ((x & (1 << 9)) >> 9);\
                          bBOARD_GPIO_PCR_PIN12 = ((x & (1 << 11)) >> 11);\
                          bBOARD_GPIO_PCR_PIN13 = ((x & (1 << 12)) >> 12);\
                          bBOARD_GPIO_PCR_PIN16 = ((x & (1 << 15)) >> 15);\
                          bBOARD_GPIO_PCR_PIN17 = ((x & (1 << 16)) >> 16);\
                          bBOARD_GPIO_PCR_PIN18 = ((x & (1 << 17)) >> 17);\
                          bBOARD_GPIO_PCR_PIN19 = ((x & (1 << 18)) >> 18);\
                          bBOARD_GPIO_PCR_PIN20 = ((x & (1 << 19)) >> 19);\
                          bBOARD_GPIO_PCR_PIN21 = ((x & (1 << 20)) >> 20);\
                          bBOARD_GPIO_PCR_PIN22 = ((x & (1 << 21)) >> 21);\
                          bBOARD_GPIO_PCR_PIN23 = ((x & (1 << 22)) >> 22);\
                          bBOARD_GPIO_PCR_PIN24 = ((x & (1 << 23)) >> 23);\
                          bBOARD_GPIO_PCR_PIN25 = ((x & (1 << 24)) >> 24);\
                          bBOARD_GPIO_PCR_PIN26 = ((x & (1 << 25)) >> 25)                              

void BoardGpio_AllOutput(void);
void BoardGpio_AllInput(void);
void BoardGpio_Set(uint32_t u32Value);                           
uint32_t BoardGpio_Get(void);

#endif /* BOARD_GPIO == ON */
#endif /*__BOARDGPIO_H__*/
